{$V-,A+,S+,R+,F+,D+}
Unit TxtShare;
  {-Unit to share TP TEXT files and set TP FileMode to support filesharing}

INTERFACE

Procedure ShareMode(Read, Write: boolean);
  {-Use before assigning typed and untyped files to set TP FileMode}
Procedure ShareAssign(Var F: Text; FileName: string;Read, Write: boolean);
  {-Assign TP TEXT files with filesharing}

IMPLEMENTATION

Type
  TextBuf = Array[0..127] OF char;

  TextRec = Record
    Handle   : word;
    Mode     : word;
    BufSize  : word;
    Private  : word;
    BufPos   : word;
    BufEnd   : word;
    BufPtr   : ^TextBuf;
    OpenFunc : Pointer;
    InOutFunc: Pointer;
    FlushFunc: Pointer;
    CloseFunc: Pointer;
    UserData : Array[1..16] Of byte;
    Name     : Array[0..79] Of char;
    Buffer   : TextBuf;
  end;

  FilRec = Record
    AccMod  : word;      { Access/Share/Inher }
    UnUsed  : Array[1..14] Of byte;
  end;

Const
  fmClosed = $D7B0;
  fmInput  = $D7B1;
  fmOutput = $D7B2;
  fmInOut  = $D7B3;

  Function fOpen(Var F: TextRec): integer;
  begin                           { open an existing file         }
    with F do
      Asm
        PUSH DS                   { Save DS                       }
        LDS  DX,F
        LDS  SI,F
        MOV  AX,[DS:SI+32]        { AL = File Access Mode  }
        ADD  DX,OFFSET Name       { ASCIIZ FileName in DS:DX      }
        MOV  AH,3Dh               { Open file                     }
        INT  21h
        JC   @1                   { jump if it was unsuccesful    }
        MOV  [DS:SI+Handle],AX    { Handle = DOS file handler nr  }
        JMP  @2                   { Finished / ready              }
@1:     OR   AH,80h               { AX = DOS Error                }
@2:     MOV  @Result,AX           { if > 8000H err occured while  }
        POP  DS                   { Restore DS                    }
      end;                        { else Nr = Hanlde              }
  end;

  Function fClose(fHandle: word): integer;
  begin                           { Close an open file            }
    Asm
      PUSH DS                     { Save DS                       }
      MOV  BX,fHandle             { file handler identifier       }
      MOV  AH,3Eh                 { close file                    }
      INT  21h
      JC   @1                     { jump if error                 }
      XOR  AX,AX                  { clear errors                  }
      JMP  @2
@1:   OR   AH,80                  { AX = DOS Error                }
@2:   MOV  @Result,AX             { if > 8000H err occured while  }
      POP  DS                     { Restore DS                    }
    end;
  end;

  Function fCreate(Var F: TextRec): integer;
  begin                           { Create a New File flush the   }
    with F do                     { file if it already exists     }
      Asm
        PUSH DS                   { Save DS                       }
        LES  SI,F
        LDS  DX,F
        ADD  DX,OFFSET Name       { ASCIIZ FileName in DS:DX      }
        MOV  CX,0                 { File attribute is normal      }
        MOV  AH,3Ch               { Create file,                  }
        INT  21h
        JC   @1                   { jump if it was unseccful      }
        MOV  [ES:SI+Handle],AX    { Handle = file handler nr      }
        JMP  @2                   { Finished / ready              }
@1:     OR   AH,80h               { AX = DOS Error                }
@2:     MOV  @Result,AX           { if > 8000H err occured while  }
        POP  DS                   { Restore DS                    }
      end;                        { else Nr = Handle              }
  end;

  Function fRead(Var F: TextRec): integer;
  begin                           { Read from file to buffer      }
    with F do
      Asm
        PUSH DS                   { Save DS                       }
        LES  SI,F
        LDS  DX,[ES:SI+BufPtr]    { DS:DX Pointer to Buffer }
        MOV  BX,[ES:SI+Handle]    { Handle                        }
        MOV  CX,[ES:SI+BufSize]   { BufSize                       }
        MOV  AH,3Fh               { Read from a File or Device    }
        INT  21h
        JC   @1                   { jump if it was unseccful      }
        MOV  [ES:SI+BufEnd],AX    { BufEnd - Antal lsta          }
        XOR  AX,AX                { Clear the error code          }
        MOV  [ES:SI+BufPos],AX    { BufPos := 0                   }
@1:     MOV  @Result,AX           { if > 0H err occured while     }
        POP  DS                   { Restore DS                    }
      end;
  end;

  Function fWrite(Var F: TextRec): integer;
  begin                           { Write the buffer to file      }
    with F do
      Asm
        PUSH DS                   { Save DS                       }
        LES  SI,F
        LDS  DX,[ES:SI+BufPtr]    { DS:DX Pointer to Buffer       }
        MOV  BX,[ES:SI+Handle]    { Handle                        }
        MOV  CX,[ES:SI+BufPos]    { BufPos                        }
        MOV  AH,40h               { Write File or Device          }
        INT  21h
        JC   @1                   { jump if it was unseccful      }
        SUB  CX,AX
        MOV  [ES:SI+BufPos],CX    { BufPos                        }
        XOR  AX,AX                { Clear the error code          }
@1:     MOV  @Result,AX           { if > 0 err occured while      }
        POP  DS                   { Restore DS                    }
      end;
  end;


  Function ReadClose(Var F: TextRec): integer;
  Var Nr : integer;
  begin
    with F do
      begin
        Nr := fClose(Handle);
        if Nr = 0 then
          begin
            Mode := fmClosed;
            ReadClose := 0;
          end
        else
          ReadClose := Nr and $FF;
      end;
  end;

  Function WriteClose(Var F: TextRec): integer;
  Var Nr : integer;
  begin
    with F do
      begin
        Nr := fClose(Handle);
        if Nr = 0 then
          begin
            Mode := fmClosed;
            WriteClose := 0;
          end
        else
          WriteClose := Nr and $FF;
      end;
  end;

  Function ReadFilFlush(Var F: TextRec): integer;
  begin                           { Do nothing (yet) }
    ReadFilFlush := 0;
  end;

  Function WriteFilFlush(Var F: TextRec): integer;
  begin                           { Write the buffer to the file }
    (*  WriteFilFlush := 0; *)
    with F do
      begin
        WriteFilFlush := fWrite(F);
      end;
  end;

  Function fSeekEof(Var F: TextRec): integer;
  begin                           { open an existing file         }
    with F do
      Asm
        PUSH DS                   { Save DS                       }
        LES  SI,F
        MOV  BX,[ES:SI+Handle]    { BX = Handle                   }
        MOV  AH,42h               { Move File Pointer             }
        MOV  AL,2                 { end of file plus the offset   }
        MOV  CX,0
        MOV  DX,0
        INT  21h
        JC   @1                   { jump if it was unsuccesful    }
        XOR  AX,AX
        MOV  [ES:SI+BufEnd],AX    { BufEnd - Antal lsta          }
        MOV  [ES:SI+BufPos],AX    { BufPos := 0                   }
        JP   @2
@1:     OR   AH,80h               { AX = DOS Error                }
@2:     MOV  @Result,AX           { if > 8000H err occured while  }
        POP  DS                   { Restore DS                    }
      end;                        { else Nr = Hanlde              }
  end;

  Function FilOpen(Var F: TextRec): integer;
  Var fh : integer;
  LABEL Err;
  begin
    with F do
      begin
        FilRec(UserData).AccMod:= ((Mode and $03)+(FileMode and $F8))-1;
        if Mode=fmInput then
          begin                   { Turbo: Reset          }
            fh := fOpen(F);       { Open file for Input   }
            if fh < 0 then goto Err
            else
              begin               { - it's okey }
                InOutFunc := @fRead;
                FlushFunc := @ReadFilFlush;
                CloseFunc := @ReadClose;
                FilOpen := 0;     { open was successfully }
              end
          end

        else
          if Mode=fmOutput then   { Turbo: Rewrite        }
            begin                 { Open file for Output  }
              fh := fCreate(F);
              if fh < 0 then goto Err
              else                { The File is created   }
                begin             { Or ReOpend/Flushed    }
                  fh := fClose(Handle);
                  if fh < 0 then goto Err
                  else
                    begin
                      fh := fOpen(F); { ReOpen file in the    }
                      if fh < 0 then goto Err { selected AccessMode   }
                      else
                        begin
                          InOutFunc := @fWrite;
                          FlushFunc := @WriteFilFlush;
                          CloseFunc := @WriteClose;
                          FilOpen   := 0; { open was successfully }
                          Exit;
                        end
                    end
                end
            end

        else { fmInOut }          { Turbo: Append         }
          begin
            fh := fOpen(F);       { Open file for Append  }
            if fh < 0 then
              begin
                fh := fCreate(F); { Try to create file    }
                if fh < 0 then goto Err;
                fh := fClose(Handle);
                if fh < 0 then goto Err;
                fh := fOpen(F);
                if fh < 0 then goto Err;
              end;

            fh := fSeekEof(F);
            if fh <> 0 then goto Err;
            InOutFunc := @fWrite;
            FlushFunc := @WriteFilFlush;
            CloseFunc := @WriteClose;
            FilOpen   := 0;
            Mode      := fmOutput;
            Exit;
          end;
        Exit;
Err:
        Mode := fmClosed;
        FilOpen := fh and $FF;    { Error could not open  }
      end;
  end;                            { FilOpen }

  Procedure ShareMode(Read, Write: boolean);
  var L : byte;
  begin
    L := 2;
    if Read and Write then L := L+64
      else if Read and (not Write) then L := L+32
        else if (not Read) and Write then L := L+48
          else L := L+16;
    FileMode := L;
  end;

  Procedure ShareAssign(Var F: Text; FileName: string;Read, Write: boolean);
  Var x : byte; { fName to file variable F    }
  begin
    ShareMode(Read, Write);
    with TextRec(F) do
      begin
        Handle     := $FFFF;
        Mode       := fmClosed;           { File is Closed    }
        BufSize    := SizeOf(Buffer);     { Buffer Size       }
        BufPtr     := @Buffer;            { Pointer to buffer }
        OpenFunc   := @FilOpen;           { Pointer File Open }
        for x := 1 to LENGTH(FileName) do { Build             }
          Name[x-1]  := FileName[x];      { ASCIIZ FileName   }
        Name[x]    := #0;                 { Terminate with #0 }
      end
  end;

begin {TxtShareUnit}
end. {TxtShareUnit}